scala.tools.nsc.backend.jvm.BCodeHelpers

# BCClassGen

###
Related Doc: package BCodeHelpers

#### trait BCClassGen extends BCInnerClassGen

Source
  BCodeHelpers.scala

Linear Supertypes
BCInnerClassGen, AnyRef, Any
Known Subclasses
PlainBodyBuilder, PlainClassBuilder, PlainSkelBuilder, SyncAndTryBuilder
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. BCClassGen
2. BCInnerClassGen
3. AnyRef
4. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Visibility

1. Public
2. All

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from BCClassGen to any2stringadd[BCClassGen] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (BCClassGen, B)

   Implicit information
     This member is added by an implicit conversion from BCClassGen to ArrowAssoc[BCClassGen] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   arg0

     the object to compare against this object for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

6. #### val MIN_SWITCH_DENSITY: Double

7. #### def addLambdaDeserialize(clazz: Global.Symbol, jclass: ClassVisitor): Unit

   Add: private static java.util.Map $deserializeLambdaCache$ = null private static Object $deserializeLambda$(SerializedLambda l) { var cache = $deserializeLambdaCache$ if (cache eq null) { cache = new java.util.HashMap() $deserializeLambdaCache$ = cache } return scala.compat.java8.runtime.LambdaDeserializer.deserializeLambda(MethodHandles.lookup(), cache, l); }

8. #### def addSerialVUID(id: Long, jclass: ClassVisitor): Unit

9. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

10. #### final def asmMethodType(msym: Global.Symbol): BTypesFromSymbols.MethodBType

    Class components that are nested classes are added to the innerClassBufferASM.

    Class components that are nested classes are added to the innerClassBufferASM. TODO: clean up the way we track referenced inner classes.

    Definition Classes
      BCInnerClassGen

11. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

12. #### def debugLevel: Int

    Definition Classes
      BCInnerClassGen

13. #### final def descriptor(sym: Global.Symbol): String

    The jvm descriptor for a symbol.

    The jvm descriptor for a symbol. If `sym` represents a nested class, its ClassBType is added to the innerClassBufferASM.

    Definition Classes
      BCInnerClassGen

14. #### final def descriptor(t: Global.Type): String

    The jvm descriptor of a type.

    The jvm descriptor of a type. If `t` references a nested class, its ClassBType is added to the innerClassBufferASM.

    Definition Classes
      BCInnerClassGen

15. #### final val emitLines: Boolean

    Definition Classes
      BCInnerClassGen

16. #### final val emitSource: Boolean

    Definition Classes
      BCInnerClassGen

17. #### final val emitVars: Boolean

    Definition Classes
      BCInnerClassGen

18. #### def ensuring(cond: (BCClassGen) ⇒ Boolean, msg: ⇒ Any): BCClassGen

    Implicit information
      This member is added by an implicit conversion from BCClassGen to Ensuring[BCClassGen] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

19. #### def ensuring(cond: (BCClassGen) ⇒ Boolean): BCClassGen

    Implicit information
      This member is added by an implicit conversion from BCClassGen to Ensuring[BCClassGen] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

20. #### def ensuring(cond: Boolean, msg: ⇒ Any): BCClassGen

    Implicit information
      This member is added by an implicit conversion from BCClassGen to Ensuring[BCClassGen] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

21. #### def ensuring(cond: Boolean): BCClassGen

    Implicit information
      This member is added by an implicit conversion from BCClassGen to Ensuring[BCClassGen] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

22. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

23. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

24. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

25. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from BCClassGen to StringFormat[BCClassGen] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

26. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

27. #### final def getClassBTypeAndRegisterInnerClass(sym: Global.Symbol): BTypesFromSymbols.ClassBType

    The ClassBType for a class symbol.

    The ClassBType for a class symbol. If the class is nested, the ClassBType is added to the innerClassBufferASM.

    TODO: clean up the way we track referenced inner classes. doing it during code generation is not correct when the optimizer changes the code.

    Definition Classes
      BCInnerClassGen

28. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

29. #### final val innerClassBufferASM: Set[BTypesFromSymbols.ClassBType]

    Definition Classes
      BCInnerClassGen

30. #### final def internalName(sym: Global.Symbol): String

    The class internal name for a given class symbol.

    The class internal name for a given class symbol. If the symbol describes a nested class, the ClassBType is added to the innerClassBufferASM.

    Definition Classes
      BCInnerClassGen

31. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

32. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

33. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

34. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

35. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

36. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

37. #### final def toTypeKind(t: Global.Type): BTypesFromSymbols.BType

    The BType for a type reference.

    The BType for a type reference. If the result is a ClassBType for a nested class, it is added to the innerClassBufferASM. TODO: clean up the way we track referenced inner classes.

    Definition Classes
      BCInnerClassGen

38. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

39. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

40. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

41. #### def →[B](y: B): (BCClassGen, B)

    Implicit information
      This member is added by an implicit conversion from BCClassGen to ArrowAssoc[BCClassGen] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from BCInnerClassGen

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from BCClassGen to any2stringadd[BCClassGen]

### Inherited by implicit conversion StringFormat from BCClassGen to StringFormat[BCClassGen]

### Inherited by implicit conversion Ensuring from BCClassGen to Ensuring[BCClassGen]

### Inherited by implicit conversion ArrowAssoc from BCClassGen to ArrowAssoc[BCClassGen]

### Ungrouped